unit fDefine;

interface

type
  TPkt0 = packed record
    ID: WORD;
    B: Byte;
    W: Word;
    I: Integer;
    S: Single;
    D: Double;
  end;

  TPkt1 = packed record
    ID: WORD;
    I: Integer;
    S: Single;
    D: Double;
  end;

  TPkt2 = packed record
    ID: WORD;
    Count: WORD;//Ƥ,̦h
    Data: array[0..4] of Single;
  end;

  PPacket = ^TPacket;
  TPacket = packed record
    case Integer of
      0:(Buff: array[0..1023] of Char);
      1:(r:packed record
            STX: Byte;      //0x30
            CRC: Byte;      //Calc XOR from Len to the byte before ETX
            Len: WORD;      //
            case PktID: Byte of//ѽX
              0:(p0: TPkt0);
              1:(p1: TPkt1);
              2:(p2: TPkt2)
            end;
        );
  end;


  procedure ClearML();
  function PacketToStr(P: PPacket): string;
  function CalcCRC(P: PChar; Len: Integer): Byte;
  function CheckCRC(P: PChar; Len: Integer): Boolean;


type
  TDecodePacket = procedure(S: string) of object;
  procedure _decode_(P: PChar; Len: Integer; Proc: TDecodePacket);

var
  M: string = '';
  L: WORD = 0;

implementation

uses SysUtils;

procedure ClearML();
begin
  M := '';
  L := 0;
end;

function PacketToStr(P: PPacket): string;
const
  FMT = 'ID:%d:%4.4d,Len=%2.2d,CRC=%2.2X';
var
  AID: WORD;
begin
  with P^.r do
  begin
    case PktID of
      0: AID := p0.ID;
      1: AID := p1.ID;
      else AID := p2.ID;
    end;
    Result := Format(FMT, [PktID, AID, Len, CRC]);
  end;
end;

function CalcCRC(P: PChar; Len: Integer): Byte;
var
  I: Integer;
begin
  Result := 0;
  for I := 2 to Len-2 do//h[0]:STX, [1]:CRC, [Len-1]:ETX
    Result := Result xor Ord(P[I]);
end;

function CheckCRC(P: PChar; Len: Integer): Boolean;
begin
  Result := Ord(P[1]) = CalcCRC(P, Len);
end;

procedure _decode_(P: PChar; Len: Integer; Proc: TDecodePacket);
var
  I: Integer;
begin
  if @Proc = nil then EXIT;

  for I := 0 to Len-1 do
  begin
    M := M + P[I];
    if M[1] <> #$30 then ClearML
    else if Length(M) = 4 then
    begin
      L := PWORD(@M[3])^;
      if L > SizeOf(TPacket) then ClearML;
    end
    else if Length(M) = L then
    begin
      if CheckCRC(PChar(M), Length(M)) then Proc(M);
      ClearML;
    end;
  end;
end;

end.
